module Beowulf
  class BaseError < StandardError
    def initialize(error, cause = nil)
      @error = error
      @cause = cause
    end
    
    def to_s
      if !!@cause
        JSON[error: @error, cause: @cause] rescue {error: @error, cause: @cause}.to_s
      else
        JSON[@error] rescue @error
      end
    end
  end
end

module Beowulf; class ApiError < BaseError; end; end
module Beowulf; class TypeError < BaseError; end; end
module Beowulf; class OperationError < BaseError; end; end
module Beowulf; class TransactionError < BaseError; end; end
module Beowulf; class WalletError < BaseError; end; end
module Beowulf; class ExtensionError < BaseError; end; end
