require 'logger'

module Beowulf
  # The logger that Beowulf uses for reporting errors.
  #
  # @return [Logger]
  def self.logger
    @@logger ||= Logger.new(STDOUT).tap do |logger|
      logger.progname = 'beowulf'
    end
  end

  # Sets the logger that Beowulf uses for reporting errors.
  #
  # @param logger [Logger] The logger to set as Beowulf's logger.
  # @return [void]
  def self.logger=(logger)
    @@logger = logger
  end
end
