module Beowulf
  module OperationTypes
    TYPES = {
      transfer: {
        amount: Type::Amount,
        fee: Type::Amount
      },
      transfer_to_vesting: {
        amount: Type::Amount
      },
      withdraw_vesting: {
        vesting_shares: Type::Amount
      },
      account_create: {
        fee: Type::Amount,
        owner: Type::Authority
      },
      account_update: {
        owner: Type::AuthorityUpdate,
        fee: Type::Amount
      }
    }
    
    def type(key, param, value)
      return if value.nil?
      t = TYPES[key] or return value
      p = t[param] or return value
      p.new(value)
    end
  end
end
