module Beowulf
  module Type
    class Amount < Serializer
      attr_reader :amount, :precision, :asset
      
      def initialize(value)
        super(:amount, value)
        @amount, @asset = value.strip.split(' ')
        @precision = 5
      end
      
      def to_bytes
        asset = @asset.ljust(9, "\x00")
        amount = (@amount.to_f * 10 ** @precision).round
        [amount].pack('q') + [@precision].pack('L') + asset
      end
      
      def to_s
        "#{@amount} #{@asset}"
      end
    end
  end
end
