require 'json'

module Beowulf
  module Type
    class AuthorityUpdate
      include Utils

      def initialize(options = {})
        # puts 'AuthorityUpdate.initialize.options', options.to_json
        @weight_threshold = options[:weight_threshold] || 1
        @account_auths = options[:account_auths] || []
        @key_auths = options[:key_auths] || []
      end

      def to_bytes
        bytes = unhexlify("01")
        wt = @weight_threshold.to_i + 0
        bytes << [wt].pack("I")
        #uint8_t
        bytes << pakC(@account_auths.length)
        if @account_auths.length > 0
          @account_auths.each do |account|
            bytes << pakStr(account[0])
            bytes << pakS(account[1])
          end
        end
        #uint8_t
        bytes << pakC(@key_auths.length)
        if @key_auths.length > 0
          @key_auths.each do |key|
            bytes << pakPubKey(key[0])
            bytes << pakS(key[1])
          end
        end
        bytes
      end

      def to_json(options = {})
        JSON.dump ({
            :weight_threshold => @weight_threshold,
            :account_auths => @account_auths,
            :key_auths => @key_auths
        })
      end

    end
  end
end


